from typing import Iterable, Protocol


class OutputSource(Protocol):
    def write(self, text: str): ...

    def write_stream(self, text: Iterable[str]): ...

    def read(self) -> str: ...

    def exists(self) -> bool: ...

    @property
    def path(self) -> str: ...

    @property
    def readable(self) -> bool: ...
